#include "Parser.h"

bool Parser::contains_help(std::string const &argument) {
    return argument == "--help" || argument == "-h";
}

void Parser::print_help() {
    std::cout << "Evaluator 1.0 is an evaluation software written as part of Lukas Majer Bachelor Thesis." << std::endl
              << "It loads output of SLAM algorithms specified in [path] and performs evaluation." << std::endl
              << "written by Lukas Majer <majerlu2@fel.cvut.cz> " << std::endl;
    std::cout << "Usage: icp_slam [path] [ OPTIONS ]" << std::endl
              << "--help -h               Output this usage screen and exits" << std::endl
              << "--ekf -e        Export SLAM output as EKF input" << std::endl;
}

bool Parser::process_arguments(int argc, char **argv) {
    bool should_terminate = false;
    if(argc < 2) {
        print_error();
        return true;
    }
    for (int i = 1; i < argc; i++) {
        if (contains_help(argv[i])) {
            print_help();
            return true;
        }
        if (i == 1) this->init.path = argv[1];
        if (contains_use_ekf(argv[i])) {
            this->init.use_ekf = true;
        }
    }
    return should_terminate;
}

bool Parser::contains_use_ekf(std::string const &argument) {
    return argument == "--ekf" || argument == "-e";
}

void Parser::print_error() {
    std::cerr << "Wrong input!" << std::endl;
}

